Subject: Re: oops in net/ipv4/icmp.c:icmp_send() with icmp_errors_use_inbound_ifaddr (fwd)

From: Patrick McHardy <[email-masked]>
Date: Mon, 21 May 2007 23:32:44 +0200

Herbert Xu wrote:
> On Mon, May 21, 2007 at 06:36:57PM +0200, Patrick McHardy wrote:
> 
>>The IP stack shouldn't be too hard, we currently set skb->dev in
>>ip_output, after that we only have the POST_ROUTING hook and ip_fragment
>>which care. It wouldn't help with ipip/ip_gre though, at that point
>>skb->dev must point to the tunnel device.
> 
> 
> I think that should be OK though.  Once you pass through ipip/ip_gre's
> transmit function, you're conceptually a locally generated packet.

Yes, but it may generate ICMP errors for the original packet before
it has passed through it. The patch I sent earlier should also handle
this case correctly.